% File : /es/lennart/2C1111/PROJEKT/NORDENPRIS/drawmcc.m
brist=0 ;
[len,col] = size(systemdata) ;
sort1 = sort([systemdata(1:len,2) ; systemdata(1:len,3)]) ;
nr1=0 ;
nr2=1 ;
while nr2<2*len
   nr1=nr1+1 ;
   prisv(nr1) = sort1(nr2) ;
   clear kk
   kk = find(sort1==prisv(nr1)) ; 
   nr2=max(kk)+1 ;
end
len1=length(prisv) ;
for i=1:len1
   prisv2(2*i-1)=prisv(i)-0.00001 ;
   prisv2(2*i)=prisv(i) ;
end
%
% Calculation of potential production
%
for i=1:2*len1
   sum1=0 ;
   for j=1:len
      if prisv2(i)>systemdata(j,3), 
         sum1 = sum1+systemdata(j,1) ;
      elseif prisv2(i)<systemdata(j,2), 
         sum1 = sum1 ;
      else
         if systemdata(j,3)==systemdata(j,2),
            sum1 = sum1 + systemdata(j,1) ;
         else
            sum1 = sum1 + (prisv2(i)-systemdata(j,2))/...
                (systemdata(j,3)-systemdata(j,2))*systemdata(j,1) ;
         end
      end
   end
   potvekt(i) = sum1 ;
end
totprodpot=potvekt(length(potvekt)) ;
%subplot(2,1,1)
plot(potvekt,prisv2)
hold on
%
% Calculation of price level
%
if(totprodpot>totload)
   kk=find(potvekt<totload) ;
   p1 = max(kk) ;
   price = prisv2(p1)+(totload-potvekt(p1))/...
        (potvekt(p1+1)-potvekt(p1))*(prisv2(p1+1)-prisv2(p1))
   plot([0 totload totload],[price price 0],'--')
%title('Marginalkostnad')
   axis([0 max(potvekt)+50 0 max(prisv2)+50])
else
   brist=1 ;
   plot([totload totload],[0 max(prisv2)+50],'--')
   if lang_var ==1,
      text(0.5*totload,0.6*max(prisv2),'Energibrist')
   else
      text(0.5*totload,0.6*max(prisv2),'Lack of energy')
   end
   axis([0 totload+50 0 max(prisv2)+50])
end
if lang_var ==1,
   xlabel('TWh/r')
   ylabel('kr/MWh')
else
   xlabel('TWh/year')
   ylabel('SEK/MWh')
end
hold off
