% File : /es/lennart/2C1111/PROJEKT/NORDENPRIS/basedata.m
% Sverige
vattenkraft_s = [65 30 40] ;
vindkraft_s = [0.6 40 60] ;
karnkraft_s = [69 70 80] ;
indmot_s = [5 80 180] ;
kraftvarme_s = [6 80 200] ;
kolkondens_s = [0 210 250] ;
oljekondens_s = [5 400 610] ;
gasturbiner_s = [6 810 890] ;
extraimport_s = [2 210 250] ;
% Norge
vattenkraft_n = [118 30 40] ;
vindkraft_n = [0 40 60] ;
karnkraft_n = [0 70 80] ;
indmot_n = [0.5 80 180] ;
kraftvarme_n = [0 80 200] ;
kolkondens_n = [0 210 250] ;
oljekondens_n = [0 400 610] ;
gasturbiner_n = [0.1 810 890] ;
extraimport_n = [0 210 250] ;
% Finland
vattenkraft_f = [13 30 40] ;
vindkraft_f = [0 40 60] ;
karnkraft_f = [21.5 70 80] ;
indmot_f = [12 80 180] ;
kraftvarme_f = [15 80 200] ;
kolkondens_f = [13 210 250] ;
oljekondens_f = [0 400 610] ;
gasturbiner_f = [3 810 890] ;
extraimport_f = [4.5 120 140] ;
% Danmark
vattenkraft_d = [0 30 40] ;
vindkraft_d = [5 40 60] ;
karnkraft_d = [0 70 80] ;
indmot_d = [2.5 80 180] ;
kraftvarme_d = [16 80 200] ;
kolkondens_d = [16 210 250] ;
oljekondens_d = [0 400 610] ;
gasturbiner_d = [1 810 890] ;
extraimport_d = [4 210 250] ;
%
load=[150 120 80 35] ;
%
systemdata = [...
vattenkraft_s ; vattenkraft_n ; vattenkraft_f ; vattenkraft_d ; ...
vindkraft_s ; vindkraft_n ; vindkraft_f ; vindkraft_d ; ...
karnkraft_s ; karnkraft_n ; karnkraft_f ; karnkraft_d ; ...
indmot_s ; indmot_n ; indmot_f ; indmot_d ; ...
kraftvarme_s ; kraftvarme_n ; kraftvarme_f ; kraftvarme_d ; ...
kolkondens_s ; kolkondens_n ; kolkondens_f ; kolkondens_d ; ...
oljekondens_s ; oljekondens_n ; oljekondens_f ; oljekondens_d ; ...
gasturbiner_s ; gasturbiner_n ; gasturbiner_f ; gasturbiner_d ; ...
extraimport_s ; extraimport_n ; extraimport_f ; extraimport_d] ;
%
totload=sum(load) ;
%
countryx1=[...
'S' 'w' 'e' 'd' 'e' 'n' ' ';
'N' 'o' 'r' 'w' 'a' 'y' ' ';
'F' 'i' 'n' 'l' 'a' 'n' 'd';
'D' 'e' 'n' 'm' 'a' 'r' 'k'] ;
countryx = countryx1 ;
countryx2=[...
'S' 'v' 'e' 'r' 'i' 'g' 'e';
'N' 'o' 'r' 'g' 'e' ' ' ' ';
'F' 'i' 'n' 'l' 'a' 'n' 'd';
'D' 'a' 'n' 'm' 'a' 'r' 'k'] ;
heads1 = [...
'H' 'y' 'd' 'r' 'o' ' ' 'P' 'o' 'w' 'e' 'r' ' ' ' ' ' ' ' ' ' ' ' ';
'W' 'i' 'n' 'd' ' ' 'P' 'o' 'w' 'e' 'r' ' ' ' ' ' ' ' ' ' ' ' ' ' ';
'N' 'u' 'c' 'l' 'e' 'a' 'r' ' ' 'P' 'o' 'w' 'e' 'r' ' ' ' ' ' ' ' ';
'I' 'n' 'd' ' ' 'B' 'a' 'c' 'k' 'p' 'r' 'e' 's' 's' 'u' 'r' 'e' ' ';
'C' 'o' 'm' 'b' '.' 'H' 'e' 'a' 't' ' ' '&' ' ' 'P' 'o' 'w' 'e' 'r';
'C' 'o' 'a' 'l' '.' 'C' 'o' 'n' 'd' 'e' 'n' 's' 'i' 'n' 'g' ' ' ' ';
'O' 'i' 'l' '' ' C' 'o' 'n' 'd' 'e' 'n' 's' 'i' 'n' 'g' ' ' ' ' ' ';
'G' 'a' 's' 't' 'u' 'r' 'b' 'i' 'n' 'e' 's' ' ' ' ' ' ' ' ' ' ' ' ';
'E' 'x' 't' 'r' 'a' ' ' 'i' 'm' 'p' 'o' 'r' 't' ' ' ' ' ' ' ' ' ' ';
'T' 'o' 't' 'a' 'l' ' ' 'p' 'r' 'o' 'd' 'u' 'c' 't' 'i' 'o' 'n' ' ';
'N' 'o' 'r' 'd' 'i' 'c' ' ' 'i' 'm' 'p' 'o' 'r' 't' ' ' ' ' ' ' ' ';
'P' 'o' 'w' 'e' 'r' ' ' 'c' 'o' 'n' 's' 'u' 'm' 'p' 't' 'i' 'o' 'n';
'N' 'o' 'r' 'd' 'i' 'c' ' ' 'c' 'o' 'n' 's' 'u' 'm' 't' 'i' 'o' 'n';
'M' 'a' 'r' 'g' 'i' 'n' 'a' 'l' ' ' 'p' 'r' 'i' 'c' 'e' ' ' ' ' ' ';
'N' 'o' 'r' 'm' 'a' 'l' ' ' 'y' 'e' 'a' 'r' ' ' ' ' ' ' ' ' ' ' ' '] ;
heads2 = [...
'V' 'a' 't' 't' 'e' 'n' 'k' 'a' 'f' 't' ' ' ' ' ' ' ' ' ' ' ' ' ' ';
'V' 'i' 'n' 'd' 'k' 'r' 'a' 'f' 't' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ';
'K' '' 'r' 'n' 'k' 'r' 'a' 'f' 't' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ';
'I' 'n' 'd' '.' 'm' 'o' 't' 't' 'r' 'y' 'c' 'k' ' ' ' ' ' ' ' ' ' ';
'K' 'r' 'a' 'f' 't' 'v' '' 'r' 'm' 'e' ' ' ' ' ' ' ' ' ' ' ' ' ' ';
'K' 'o' 'l' 'k' 'o' 'n' 'd' 'e' 'n' 's' ' ' ' ' ' ' ' ' ' ' ' ' ' ';
'O' 'l' 'j' 'e' 'k' 'o' 'n' 'd' 'e' 'n' 's' ' ' ' ' ' ' ' ' ' ' ' ';
'G' 'a' 's' 't' 'u' 'r' 'b' 'i' 'n' 'e' 'r' ' ' ' ' ' ' ' ' ' ' ' ';
'E' 'x' 't' 'r' 'a' ' ' 'i' 'm' 'p' 'o' 'r' 't' ' ' ' ' ' ' ' ' ' ';
'T' 'o' 't' 'a' 'l' ' ' 'p' 'r' 'o' 'd' 'u' 'k' 't' 'i' 'o' 'n' ' ';
'N' 'o' 'r' 'd' 'e' 'n' 'i' 'm' 'p' 'o' 'r' 't' ' ' ' ' ' ' ' ' ' ';
'E' 'l' 'f' '' 'r' 'b' 'r' 'u' 'k' 'n' 'i' 'n' 'g' ' ' ' ' ' ' ' ';
'N' 'o' 'r' 'd' 'i' 's' 'k' ' ' 'k' 'o' 'n' 's' 'u' 'm' 't' '.' ' ';
'M' 'a' 'r' 'g' 'i' 'n' 'a' 'l' 'p' 'r' 'i' 's' ' ' ' ' ' ' ' ' ' ';
'N' 'o' 'r' 'm' 'a' 'l' '' 'r' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' '] ;
maintxt1 = [...
'P' 'o' 'w' 'e' 'r' ' ' 'S' 'o' 'u' 'r' 'c' 'e' ' ' ' ';
'T' 'W' 'h' '/' 'y' 'e' 'a' 'r' ' ' ' ' ' ' ' ' ' ' ' ';
'S' 'E' 'K' '/' 'M' 'W' 'h' ' ' ' ' ' ' ' ' ' ' ' ' ' ';
'P' 'o' 't' '.' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ';
'P' 'r' 'o' 'd' '.' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ';
'l' 'o' 'w' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ';
'h' 'i' 'g' 'h' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ';
'M' 'S' 'E' 'K' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ';
'T' 'o' 't' 'a' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ' ';
'N' 'o' 'r' 'd' 'i' 'c' ' ' 'i' 'm' 'p' 'o' 'r' 't' ' ';
'C' 'o' 'n' 's' 'u' 'm' 'p' 't' 'i' 'o' 'n' ' ' ' ' ' ';
'M' 'a' 'r' 'g' 'i' 'n' 'a' 'l' ' ' 'p' 'r' 'i' 'c' 'e'] ;
maintxt2 = maintxt1 ;
