% Positions for the countries
for i=1:4
   country_t(i) = uicontrol(gcf,'Style','text','Position',...
                  [10+180*i 680 178 30]) ;
end
% Positions for the units
for i=1:8
   unit_t(i) = uicontrol(gcf,'Style','text','Position',...
                  [100+90*i 648 88 30]) ;
end
% Positions for the data headlines
for i=1:16
   head_t(i) = uicontrol(gcf,'Style','text','Position',... 
                  [145+45*i 616 43 30]) ;
end
% Positions for the power sources
for i=1:12
   source_t(i) = uicontrol(gcf,'Style','text','Position',... 
                  [30 616-28*i 158 26]) ;
end
% Positions for data and results
for i=1:9
for j=1:4
   pot_x(i,j) = uicontrol(gcf,'Style','edit','Position',... 
                  [10+180*j 616-28*i 43 26],...
	          'CallBack',['checkdata,'],...
		  'BackgroundColor',[1 1 1]) ;
   prod_x(i,j) = uicontrol(gcf,'Style','text','Position',... 
                  [55+180*j 616-28*i 43 26]) ;
   low_x(i,j) = uicontrol(gcf,'Style','edit','Position',... 
                  [100+180*j 616-28*i 43 26],...
	          'CallBack',['checkdata,'],...
		  'BackgroundColor',[1 1 1]) ;
   high_x(i,j) = uicontrol(gcf,'Style','edit','Position',... 
                  [145+180*j 616-28*i 43 26],...
	          'CallBack',['checkdata,'],...
		  'BackgroundColor',[1 1 1]) ;
end
end
for j=1:4
   total_x(j) = uicontrol(gcf,'Style','text','Position',...
                  [10+180*j 336 88 26]) ;
   nordimp_x(j) = uicontrol(gcf,'Style','edit','Position',...
                  [10+180*j 308 88 26]) ;		  
   load_x(j) = uicontrol(gcf,'Style','edit','Position',...
                  [10+180*j 280 88 26],...
	          'CallBack',['checkload,'],...			 
		  'BackgroundColor',[1 1 1]) ;
end
lang = uicontrol(gcf,'Style','radio','Position',[30 680 158 30],...
		 'Callback',['language'],...
		  'BackgroundColor',[1 1 1]) ;
for i=13:14
   source_t(i) = uicontrol(gcf,'Style','text','Position',... 
                  [30 588-28*i 158 26]) ;
end
source_t(15) = uicontrol(gcf,'Style','radio','Position',... 
                  [30 588-28*15 158 26],'Callback',['orig'],...
		  'BackgroundColor',[1 1 1]) ;
result_x(1) = uicontrol(gcf,'Style','text','Position',...
			[190 224 108 26]) ;
result_x(2) = uicontrol(gcf,'Style','text','Position',...
			[190 196 108 26]) ;
title = uicontrol(gcf,'Style','text','Position',...
		  [190 716 538 28],...
		  'String','N O R D I C - P R I C E')
copyright = uicontrol(gcf,'Style','text','Position',...
		  [30 30 180 28],'String','Lennart Sder, 1999')
exit_x = uicontrol(gcf,'Style','radio','Position',...
		  [30 112 158 26],'Callback',['exit'],...
		 'String','Exit',...
		 'BackgroundColor',[1 1 1]) ;
